#ifndef ENDIANSWAP_IO_H
#define ENDIANSWAP_IO_H

size_t ES_fwrite_short(const short * buf, size_t nmemb, FILE *
		       stream);
size_t ES_fwrite_int(const int * buf, size_t nmemb, FILE * stream);
size_t ES_fwrite_float(const float * buf, size_t nmemb, FILE *
		       stream);
size_t ES_fwrite_double(const double * buf, size_t nmemb, FILE *
			stream);
size_t ES_fwrite_swap(const void * buf, size_t size, size_t nmemb, FILE *
		      stream);
size_t ES_fread_short(short * buf, size_t nmemb, FILE * stream);
size_t ES_fread_int(int * buf, size_t nmemb, FILE * stream);
size_t ES_fread_float(float * buf, size_t nmemb, FILE * stream);
size_t ES_fread_double(double * buf, size_t nmemb, FILE * stream);
size_t ES_fread_swap(double * buf, size_t size, size_t nmemb, FILE *
		     stream);

#endif
