// /***************************************************************************
//  *   Copyright (C) 2006 by Nicolas PASCAL   *
//  *   pascal@icare-pc12   *
//  *                                                                         *
//  *   This program is free software; you can redistribute it and/or modify  *
//  *   it under the terms of the GNU General Public License as published by  *
//  *   the Free Software Foundation; either version 2 of the License, or     *
//  *   (at your option) any later version.                                   *
//  *                                                                         *
//  *   This program is distributed in the hope that it will be useful,       *
//  *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
//  *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
//  *   GNU General Public License for more details.                          *
//  *                                                                         *
//  *   You should have received a copy of the GNU General Public License     *
//  *   along with this program; if not, write to the                         *
//  *   Free Software Foundation, Inc.,                                       *
//  *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
//  ***************************************************************************/
//
#include "gmaofiledata.h"
//
 int main(int argc, char *argv[]) {
//     unsigned short nb_height_level;
//     unsigned short nb_time_level;
//     double* height_level=NULL;
//     double* time_level=NULL;
//     int idx_2d[2];
//     int idx_3d[]={0,-1,-1};
//     int edges_3d[]={1,1,1};
//     float lat,lon;
//     Date d;
//
//     /**************************************/
//     /********** MISC INFOMATIONS **********/
//     /**************************************/
//
//     /*********** GMAO GEOS-4 meteo file ***********/
//     cout<<"***** GMAO-4 (tsyn2d_mis_x) *****"<<endl;
//     GMAOFileData f2("/home/pascal/DATA/GMAO/GEOS-4/DAS.llk.asm.tsyn2d_mis_x.GEOS403.2007010100.2007010121.V01");
//     /* print out some informations */
//     cout<<"Product ID "<<f2.get_product_id()<<endl;
//     cout<<"GEOS version "<<f2.get_geos_version()<<endl;
//     cout<<"Date "<<f2.get_date()<<endl;
//     cout<<"Time Coverage (seconds) "<<f2.get_time_coverage()<<endl;
//     cout<<"Grid Resolution (lat,lon) ("<< f2.get_delta_lat()<<","<<f2.get_delta_lon()<<")"<<endl;
//     /* check profile levels */
//     height_level=(double*)(f2.get_height_level());
//     nb_height_level=f2.get_nb_height_level();
//     cout<<"Heights\t";
//     for (int i=0;i<nb_height_level;++i)
//       cout<<height_level[i]<<"\t";
//     cout<<endl;
//     time_level=(double*)(f2.get_time_level());
//     nb_time_level=f2.get_nb_time_level();
//     cout<<"Times\t";
//     for (int i=0;i<nb_time_level;++i)
//       cout<<time_level[i]<<"\t";
//     cout<<endl;
//     /*********** GMAO GEOS-4 meteo file ***********/
//     cout<<"***** GMAO-4 (tsyn3d_mis_p) *****"<<endl;
//     GMAOFileData f4("/home/pascal/DATA/GMAO/GEOS-4/DAS.llk.asm.tsyn3d_mis_p.GEOS403.2007010100.2007010118.V01");
//     /* print out some informations */
//     cout<<"Product ID "<<f4.get_product_id()<<endl;
//     cout<<"GEOS version "<<f4.get_geos_version()<<endl;
//     cout<<"Date "<<f4.get_date()<<endl;
//     cout<<"Time Coverage (seconds) "<<f4.get_time_coverage()<<endl;
//     cout<<"Grid Resolution (lat,lon) ("<< f4.get_delta_lat()<<","<<f4.get_delta_lon()<<")"<<endl;
//     cout<<"Nb Height levels "<<f4.get_nb_height_level()<<endl;
//     cout<<endl;
//     /* check profile levels */
//     height_level=(double*)(f4.get_height_level());
//     nb_height_level=f4.get_nb_height_level();
//     cout<<"Heights\t";
//     for (int i=0;i<nb_height_level;++i)
//       cout<<height_level[i]<<"\t";
//     cout<<endl;
//     time_level=(double*)(f4.get_time_level());
//     nb_time_level=f4.get_nb_time_level();
//     cout<<"Times\t";
//     for (int i=0;i<nb_time_level;++i)
//       cout<<time_level[i]<<"\t";
//     cout<<endl;
//     /*********** GMAO GEOS-5 meteo file ***********/
//     cout<<"***** GMAO-5 (inst2d_met_x) *****"<<endl;
//     GMAOFileData f("/home/pascal/DATA/GMAO/GEOS-5/D5CALIP1.ops.asm.inst2d_met_x.GEOS501.20070618_0000.V01.hdf");
//     cout<<"Product ID "<<f.get_product_id()<<endl;
//     cout<<"GEOS version "<<f.get_geos_version()<<endl;
//     cout<<"Date "<<f.get_date()<<endl;
//     cout<<"Time Coverage (seconds) "<<f.get_time_coverage()<<endl;
//     cout<<"Grid Resolution (lat,lon) ("<< f.get_delta_lat()<<","<<f.get_delta_lon()<<")"<<endl;
//     cout<<endl;
//     /* check profile levels */
//     height_level=(double*)(f.get_height_level());
//     nb_height_level=f.get_nb_height_level();
//     cout<<"Heights\t";
//     for (int i=0;i<nb_height_level;++i)
//       cout<<height_level[i]<<"\t";
//     cout<<endl;
//     time_level=(double*)(f.get_time_level());
//     nb_time_level=f.get_nb_time_level();
//     cout<<"Times\t";
//     for (int i=0;i<nb_time_level;++i)
//       cout<<time_level[i]<<"\t";
//     cout<<endl;
//     /*********** GMAO GEOS-5 meteo file ***********/
//     cout<<"***** GMAO-5 (inst3d_met_p) *****"<<endl;
//     GMAOFileData f3("/home/pascal/DATA/GMAO/GEOS-5/D5CALIP2.ops.asm.inst3d_met_p.GEOS501.20070609_0600.V01.hdf");
//     /* print out some informations */
//     cout<<"Product ID "<<f3.get_product_id()<<endl;
//     cout<<"GEOS version "<<f3.get_geos_version()<<endl;
//     cout<<"Date "<<f3.get_date()<<endl;
//     cout<<"Time Coverage (seconds) "<<f3.get_time_coverage()<<endl;
//     cout<<"Grid Resolution (lat,lon) ("<< f3.get_delta_lat()<<","<<f3.get_delta_lon()<<")"<<endl;
//     cout<<"Nb Height levels "<<f3.get_nb_height_level()<<endl;
//     cout<<endl;
//     /* check profile levels */
//     height_level=(double*)(f3.get_height_level());
//     nb_height_level=f3.get_nb_height_level();
//     cout<<"Heights\t";
//     for (int i=0;i<nb_height_level;++i)
//       cout<<height_level[i]<<"\t";
//     cout<<endl;
//     time_level=(double*)(f3.get_time_level());
//     nb_time_level=f3.get_nb_time_level();
//     cout<<"Times\t";
//     for (int i=0;i<nb_time_level;++i)
//       cout<<time_level[i]<<"\t";
//     cout<<endl;
//     /************************************************************/
//     /********** (lat,lon) to indexes retrieval methods **********/
//     /************************************************************/
//
//     /*********** In GMAO GEOS-5 2D meteo file ***********/
//     cout<<"***** GMAO-5 (inst2d_met_x) *****"<<endl;
//     lat=-90.; lon=-180.;
//     if (f.get_index(lat,lon,idx_2d)) // coincidence at [0,0]
//       cout<<"Coincidence of ("<<lat<<","<<lon<<") found at ["<<idx_2d[0]<<","<<idx_2d[1]<<"]"<<endl;
//     else
//       cout<<"Coincidence NOT found"<<endl;
//
//     lat=90.;lon=180.;
//     if (f.get_index(lat,lon,idx_2d)) // coincidence at [360,0]
//       cout<<"Coincidence of ("<<lat<<","<<lon<<") found at ["<<idx_2d[0]<<","<<idx_2d[1]<<"]"<<endl;
//     else
//       cout<<"Coincidence NOT found"<<endl;
//
//     lat=90.;lon=178.;
//     if (f.get_index(lat,lon,idx_2d)) // coincidence at [360,537]
//       cout<<"Coincidence of ("<<lat<<","<<lon<<") found at ["<<idx_2d[0]<<","<<idx_2d[1]<<"]"<<endl;
//     else
//       cout<<"Coincidence NOT found"<<endl;
//
//     lat=-56.5;lon=8.;
//     if (f.get_index(lat,lon,idx_2d)) // coincidence at [67,282]
//       cout<<"Coincidence of ("<<lat<<","<<lon<<") found at ["<<idx_2d[0]<<","<<idx_2d[1]<<"]"<<endl;
//     else
//       cout<<"Coincidence NOT found"<<endl;
//
//     /***************************************/
//     /********** Read Data methods **********/
//     /***************************************/
//     float32 val;
//
//     /*********** GMAO GEOS-5 3D meteo file ***********/
//     cout<<"***** GMAO-5 (inst3d_met_p) *****"<<endl;
//     lat=-56.5;lon=8.;
//     f.get_index(lat,lon,idx_2d); // coincidence at [67,282]
//     // GMAO-5 SDS have 3 dimensions, but the first one is not used -> map 2D selector to 3D one
//     idx_3d[1]=idx_2d[0];
//     idx_3d[2]=idx_2d[1];
//
//     f.read_data(&val,"TSKIN",idx_3d,NULL,edges_3d); // read the Skin Temp -> 272.1949
//     cout<<"TSKIN at ["<<idx_2d[0]<<","<<idx_2d[1]<<"] -> "<<val<<endl;
//
//     return 0;
}
