/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "hdf5filedata.h"
#include "omifiledata.h"
#include "hdffiledata.h"
#include "hdffilemetadata.h"

int main(int argc, char *argv[]) {
  /********** TEST DIRECTORIES FUNCTIONS **********/

   HDF5FileData *d = new OMIFileData(string("/DATA/LIENS/OMI/OMCLDO2.v003/2008/2008_07_20/OMI-Aura_L2-OMCLDO2_2008m0720t0029-o21345_v003-2008m0720t075750.he5"));

   //HDFFileMetaData *meta = new HDFFileMetaData("/DATA/LIENS/OMI/OMCLDO2.v003/2008/2008_07_20/OMI-Aura_L2-OMCLDO2_2008m0720t0029-o21345_v003-2008m0720t075750.he5");

   //meta->view_tree();

   vector<int> vect;
   string stg;
//    float64 f;

    d->open_data_file();

   int n = d-> get_n_dataset();

   for(int i=0; i<n; i++){
    stg = d->get_dataset_name(i);
    cout<<stg<<endl;
    //vect=d->get_dataset_dimension(stg);
    //for(uint j=0; j<vect.size(); j++) cout<<vect[j]<<" ";
    //d->get_dataset_fill_value(stg,&f);
    //cout<<d->get_dataset_data_type(stg)<<" ";
    //cout<<" fill value : "<<f<<endl;
    string attr ="RANGEENDINGDATE";
    if(d->has_attr(attr)){
        cout<<d->get_values_attr(attr)<<endl;
    }else cout<<endl;

    void *data = NULL;
    d->read_data(data,stg.c_str());
   }

   d->close_data_file();

   delete d;

  /********** TEST FILES FUNCTIONS **********/


  return(1);
};

