#ifndef ENDIANSWAP_MEM_H
#define ENDIANSWAP_MEM_H
short * ES_memcpy_short(short * dest, const short * src, size_t
			count);
int * ES_memcpy_int(int * dest, const int * src, size_t count);
float * ES_memcpy_float(float * dest, const float * src, size_t
			count);
double * ES_memcpy_double(double * dest, const double * src, size_t
			  count);
void * ES_memcpy_swap(void * dest, const void * src, size_t count,
			size_t size);
short * ES_memmove_short(short * dest, const short * src, size_t
			count);
int * ES_memmove_int(int * dest, const int * src, size_t count);
float * ES_memmove_float(float * dest, const float * src, size_t
			count);
double * ES_memmove_double(double * dest, const double * src, size_t
			  count);
void * ES_memmove_swap(void * dest, const void * src, size_t count,
			size_t size);
#endif
