/***************************************************************************
 *   Copyright (C) 2006 by Nicolas PASCAL   *
 *   pascal@icare-pc12   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "parasolfiledata.h"

int main(int argc, char *argv[]) {
//     bool show_val_display=true;
    string filename("/DATA/PARASOL/LS2/2009/2009_01_01/P3L2TLGC094003KL");
    PARASOLFileData pfd(filename);
//     int nb_data=pfd.get_nb_data();

    // ***** test some attributes building *****
    cout<<"-------------------------------------------------------"<<endl;
    cout<<"Instrument "<<pfd.get_instrument()<<endl;
    cout<<"Level "<<pfd.get_level()<<endl;
    cout<<"Processing line "<<pfd.get_processing_line_string()<<endl;
    cout<<"Product "<<pfd.get_product()<<endl;
    cout<<"Orbit cycle number "<<pfd.get_orbit_cycle_nb()<<endl;
    cout<<"Orbit number "<<pfd.get_orbit_nb()<<endl;
    cout<<"Reprocessing number "<<pfd.get_reprocessing_nb()<<endl;
    cout<<"Radix "<<pfd.get_radix()<<endl;
    cout<<"Software Version Number "<<pfd.get_software_version_number()<<endl;

    // ***** test geolocation data reading *****
    /*
    Init the geolocation data : it loads the lat,lon indexes in memory. To mandatory, but fasten methods that map lat,lon indexes to a record index like get_index(lat,lon,rec_idx).
    */
    pfd.load_geolocation_data();

//     unsigned short* lin=const_cast<unsigned short*>(pfd.get_line_data());
//     unsigned short* col=const_cast<unsigned short*>(pfd.get_col_data());
//     if (show_val_display) {
//         cout<<"line\tcolumn"<<endl;
//         for (int i = 0 ; i<nb_data ; ++i)
//             cout<<lin[i]<<"\t"<<col[i]<<endl;
//     }
//     cout<<"-------------------------------------------------------"<<endl; // OK
//
//     // ***** test param reading methods *****
//     unsigned short nb_bytes;
//     double slope,offset;
//     unsigned char *count_data=NULL; // data buffers must have the same type than read data. See DPC for that
//     unsigned int *ulong_count_data=NULL;
//     unsigned short *ushort_count_data=NULL;
//     signed short *short_count_data=NULL;
//     double* scaled_data=NULL;
//     string param;
//     vector<int> dimensions;
//     int nb_data_record=-1;
//     int nb_viewing_directions=-1;
//
//     int start[]={0,0}; // means : start to read the data from the first record (0), and from the 1st viewing direction (0)
//     int edges[]={-1,1}; // means : read all the records (-1 is a kind of metaselector), and read only one viewing direction value (1)

    return 0;
}
